# Visual Studio Code Ruby Extensions

[![CI](https://img.shields.io/github/workflow/status/rubyide/vscode-ruby/CI.svg?logo=github)](https://github.com/rubyide/vscode-ruby/actions?query=workflow%3ACI)
[![codecov](https://codecov.io/gh/rubyide/vscode-ruby/branch/master/graph/badge.svg)](https://codecov.io/gh/rubyide/vscode-ruby)

This is the monorepo for the Visual Studio Code Ruby extensions.

Head on over to the [Ruby extension README](https://github.com/rubyide/vscode-ruby/blob/master/packages/vscode-ruby-client/README.md) to get started!

## Packages

- [`vscode-ruby`](https://github.com/rubyide/vscode-ruby/blob/master/packages/vscode-ruby) - extension providing syntax highlighting, language configuration, and snippets for Ruby
- [`vscode-ruby-client`](https://github.com/rubyide/vscode-ruby/blob/master/packages/vscode-ruby-client) - extension logic including the language server client
- [`vscode-ruby-common`](https://github.com/rubyide/vscode-ruby/blob/master/packages/vscode-ruby-common) - common utilities that are shared among several other packages (eg environment detection)
- [`vscode-ruby-debugger`](https://github.com/rubyide/vscode-ruby/blob/master/packages/vscode-ruby-debugger) - implementation of the debugger
- [`language-server-ruby`](https://github.com/rubyide/vscode-ruby/blob/master/packages/language-server-ruby) - language server implementation
  <!-- - [`ruby-debug-ide-protocol`](https://github.com/rubyide/vscode-ruby/blob/master/packages/ruby-debug-ide-protocol) - implementation of the [ruby-debug-ide protocol](https://github.com/ruby-debug/ruby-debug-ide/blob/master/protocol-spec.md)r -->

## Docs

Documentation is available in the [docs](https://github.com/rubyide/vscode-ruby/tree/master/docs) folder

## Troubleshooting

Troubleshooting documentation is available [here](https://github.com/rubyide/vscode-ruby/tree/master/docs/troubleshooting.md) folder

## Developing

See the [developing](https://github.com/rubyide/vscode-ruby/blob/master/docs/developing.md) docs
